﻿/*
 * Created by SharpDevelop.
 * User: usertdkit2
 * Date: 24.12.2009
 * Time: 10:12
 * 
 * To change this template use Tools | Options | Coding | Edit Standard Headers.
 */

using System;
using System.Collections.Generic;
using System.Drawing;
using System.Windows.Forms;

using System.IO.Ports;
using System.Timers;

namespace ModBusReader
{
	/// <summary>
	/// Description of MainForm.
	/// </summary>
	public partial class MainForm : Form
	{
		
		SerialPort SPort;
		CRCCalculator CRC = new CRCCalculator();
		public int flt;
		public String ByteToString;
		public String ByteToString1;
		public String ByteToString2;
		public String ByteToString3;
		public String ByteToString4;
		public byte[] result;
		//Timer MyTimer = new Timer();
		
		public MainForm()
		{
			//
			// The InitializeComponent() call is required for Windows Forms designer support.
			//
			InitializeComponent();
			
			//
			// TODO: Add constructor code after the InitializeComponent() call.
			//
			
			btnStop.Enabled = false;
			
			string[] ports = SerialPort.GetPortNames();

            foreach (string port in ports)
            {
                lstPorts.Items.Add(port);
            }
			lstPorts.SelectedIndex = 0;
			
			string[] baudrates = { "230400", "115200", "57600", "38400", "19200", "9600" };

            foreach (string baudrate in baudrates)
            {
                lstBaudrate.Items.Add(baudrate);
            }

            lstBaudrate.SelectedIndex = 5;
			
            SPort = new SerialPort(lstPorts.Text);
            SPort.BaudRate = Convert.ToInt32(lstBaudrate.SelectedItem.ToString());
            SPort.Parity = Parity.Even;
			SPort.DataBits = 8;
			SPort.StopBits = StopBits.One;
			SPort.ReadTimeout = 2000;
			SPort.WriteTimeout = 1000;
			
			//Интервал 1000 - 1 секунда
			MyTimer.Interval = 1000;
            
		}
		
		void BtnStartClick(object sender, EventArgs e)
		{
			SPort.Open();
			btnStart.Enabled = false;
			btnStop.Enabled = true;
			lstPorts.Enabled = false;
			lstBaudrate.Enabled = false;
			lblStatus.Text = "Порт открыт";
			MyTimer.Start();
			MyTimer.Tick += new EventHandler(ReadFunction);
			//ReadFunction();
		}
		
		void BtnStopClick(object sender, EventArgs e)
		{
			SPort.Close();
			btnStart.Enabled = true;
			btnStop.Enabled = false;
			lstPorts.Enabled = true;
			lstBaudrate.Enabled = true;
			lblStatus.Text = "Порт закрыт";
			MyTimer.Stop();
		}
		private Single ConvertHexToSingle(string hexVal)
		{
               int i=0, j=0;
               byte[] bArray = new byte[4];
               for (i = 0; i <= hexVal.Length-1; i += 2) {
                   bArray[j] = Byte.Parse (hexVal[i].ToString() + hexVal[i + 1].ToString(), System.Globalization.NumberStyles.HexNumber);
                   j += 1;
               }
               Array.Reverse (bArray);
               Single s =  BitConverter.ToSingle (bArray, 0);
               return (s);
		}
		private void ReadFunction(object sender, EventArgs eArgs)
        {
			string str_out;
			//int intBytes;
			
			byte device_address=Convert.ToByte(txtDeviceAddress.Text);
			byte data_type = 0x03;
			Int64 start_address = Convert.ToInt64(txtStartAddress.Text);
			//start_address = 0x28;
			Int64 amount_bytes = 2;
			start_address=start_address -1;
			
			Int64 start_address_higer=start_address/256;
			Int64 start_address_lower=start_address % 256;
			
			Int64 amount_bytes_higer=amount_bytes/256;
			Int64 amount_bytes_address_lower=amount_bytes % 256;
			
			
			byte[] toSend = new byte[8];
            
            toSend[0] = device_address;
			toSend[1] = data_type;
			toSend[2] = (byte)start_address_higer;
			toSend[3] = (byte)start_address_lower;
			toSend[4] = (byte)amount_bytes_higer;
			toSend[5] = (byte)amount_bytes_address_lower;
			
			#region CRC true
			//правильно
			int crc_result=CRC.crc16(toSend, 6);
			byte[] crc_bytes=BitConverter.GetBytes(crc_result);

			toSend[6]= crc_bytes[1];
			toSend[7]= crc_bytes[0];
			#endregion
			
			#region read SerialPort
			byte[] buf = new byte[5 + 2*(amount_bytes)];
            str_out = Convert.ToString(toSend);	
            SPort.Write(toSend, 0, 8);  
            int btor = SPort.BytesToRead;
            
            for (int i = 0; i < (5 + 2*(amount_bytes)); i++)
            {
                buf[i] = (byte)(SPort.ReadByte());
            }
            #endregion
            
            #region add columns
            int j = buf.Length;
            if (lvRegisterValues.Columns.Count < buf.Length - 1)
            {
            	for(int i = 3; i < (Convert.ToInt32(buf[2]) + 3); i++)
            	{
            		lvRegisterValues.Columns.Add("Байт " + Convert.ToString(i-2));
            		lvRegisterValues.Columns[lvRegisterValues.Columns.Count-1].Width = 45;
            	}
            	lvRegisterValues.Columns.Add("CRC 1");
            	lvRegisterValues.Columns[lvRegisterValues.Columns.Count-1].Width = 45;
            	lvRegisterValues.Columns.Add("CRC 2");   
            	lvRegisterValues.Columns[lvRegisterValues.Columns.Count-1].Width = 45;
            	lvRegisterValues.Columns.Add("Float"); 
            }
            #endregion
            
            lvRegisterValues.Items.Add(buf[0].ToString());
            lvRegisterValues.Items[lvRegisterValues.Items.Count - 1].SubItems.Add(buf[1].ToString());
            lvRegisterValues.Items[lvRegisterValues.Items.Count - 1].SubItems.Add(buf[2].ToString());
            
            for(int i = 3; i < (Convert.ToInt32(buf[2]) + 3); i++)
            	lvRegisterValues.Items[lvRegisterValues.Items.Count - 1].SubItems.Add(buf[i].ToString());

            lvRegisterValues.Items[lvRegisterValues.Items.Count - 1].SubItems.Add(buf[Convert.ToInt32(buf[2]) + 3].ToString());
            lvRegisterValues.Items[lvRegisterValues.Items.Count - 1].SubItems.Add(buf[Convert.ToInt32(buf[2]) + 4].ToString());
                       
            result = new byte[4];
            
            result[0] = buf[3];
            result[1] = buf[4];
            result[2] = buf[5];
            result[3] = buf[6];
      
            ByteToString1 = String.Format("{0:X}", Convert.ToInt32(result[0]));
            ByteToString2 = String.Format("{0:X}", Convert.ToInt32(result[1]));
            ByteToString3 = String.Format("{0:X}", Convert.ToInt32(result[2]));
            ByteToString4 = String.Format("{0:X}", Convert.ToInt32(result[3]));
           
            if(ByteToString1.Length == 1) ByteToString1 = "0" + ByteToString1;
            if(ByteToString2.Length == 1) ByteToString2 = "0" + ByteToString2;
            if(ByteToString3.Length == 1) ByteToString3 = "0" + ByteToString3;
            if(ByteToString4.Length == 1) ByteToString4 = "0" + ByteToString4;
            
            ByteToString = 	ByteToString1 + 
            				ByteToString2 +
            				ByteToString3 +
            				ByteToString4;
            
            Single asd = ConvertHexToSingle(ByteToString);
            lvRegisterValues.Items[lvRegisterValues.Items.Count - 1].SubItems.Add(asd.ToString());            
		}
		
		void MainFormLoad(object sender, EventArgs e)
		{
			
		}
	}
}
